

% static_force

% Berechnet die statische Kraft, die die Anziehung durch den Notausgang
% modelliert

function [force_mat_x, force_mat_y] = static_force(d,b,l,door,c_1,c_static);

% Erstelle eine Matrix, die die Felder des Raumes interpretiert
radius_mat = zeros(l,b./2);

% Berechne den Abstand zu den statischen Anziehungspunkten fr jedes Feld

N_left_fields = (b - door) ./ 2; 


% Berechnet die Abstnde fr den linken Fluchtpunkt
for j = 1 : N_left_fields;
    
    for i = 1:l
    
    radius_mat(i,j) =  sqrt( ((N_left_fields +1 - j) .* d) .^2 + ( (l + 1 - i) .* d - d./2 ) .^2 );
    
    end
    
end

%Berechnet die Abstnde fr die linken zentralen Felder
for j = (N_left_fields + 1) : (b./2)

    for i = 1:l
    
    radius_mat(i,j) =  (l + 1 - i) .* d - d./2 ;
    
    end
    
end

% Berechnet die Winkel
for j = 1 : N_left_fields
    
    for i = 1:l
    
    alpha_x(i,j) = (N_left_fields +1 - j) .* d;
    
    alpha_y(i,j) = (l + 1 - i) .* d - d./2;
    
    end
    
end

% Winkel fr den linken Block
alpha_links = atan(alpha_y ./ alpha_x);

% Winkel fr den Mittelblock
alpha_mitte = (pi ./2 ) .* ones(l, door/2);

% Winkel fr gesamt linke Hlfte

alpha_mat = [alpha_links, alpha_mitte];

%Berechne die Krfte die in jedem Feld herrschen

force_mat = c_1 .* radius_mat .^ (-1) + c_static;

% Erstelle einen Plot des Kraftfeldes

force_mat_inv = fliplr(force_mat);

bar3([force_mat, force_mat_inv])

pause
 
% Berechne daraus die x_Koordinate

force_mat_x = force_mat .* cos(alpha_mat);

inv_force_mat = (-1) .* fliplr(force_mat_x);

force_mat_x = [force_mat_x,inv_force_mat];


% Berechne daraus die y_Koordinate

force_mat_y = force_mat .* sin(alpha_mat);

inv_force_mat =fliplr(force_mat_y);

force_mat_y = [force_mat_y,inv_force_mat];

