
% variable_force_grav.m
% Berechnet die "Anziehungskraft" zwischen den Personen

function [grav_force_x, grav_force_y] = variable_force_grav(people_mat,n,c_2,r_min)


% Initialisiert die Vektoren
grav_force_x = zeros(n,1);

grav_force_y = zeros(n,1);


% Berechnungsschleife fr die x- und die y-Koordinate
% Jede Person agiert mit jeder

for i = 1:n
    
    for j = 1:i-1
        
        
        % Berechne die Abstnde und die Steigungen untereinander
        r_square = max( (people_mat(j,1) - people_mat(i,1)).^2 + (people_mat(j,2) - people_mat(i,2)).^2, r_min^2);
        
        if people_mat(j,1) ~= people_mat(i,1)
        
            delta_square = (people_mat(j,2) - people_mat(i,2)).^2 ./ (people_mat(j,1) - people_mat(i,1)).^2;
        
            % Berechne die komponentenweisen Krfte
            force_x = c_2 ./ ( r_square .* sqrt( delta_square + 1 ) );
        
            force_y = ( c_2 .* sqrt( delta_square) ) ./ ( r_square .* sqrt( delta_square + 1 ) );
        
            % Bestimme die Richtung, in die die komponentenweise Kraft zeigt 
            % fr x
            
        else
            
            force_x = 0;
            force_y = ( c_2 ) ./ ( r_square );
            
        end
            
            
        if people_mat(j,1) < people_mat(i,1)
            
            force_x = - force_x;
            
        else

        end
        
        % Bestimme die Richtung, in die die komponentenweise Kraft zeigt
        % fr y
        if people_mat(j,2) < people_mat(i,2)
            
            force_y = - force_y;
            
        else

        end        
        
        % Summiere die einzelnen komponentenweisen Krfte zu einer
        % Gsamtkraft auf
        grav_force_x(i) = grav_force_x(i) + force_x ;
        
        grav_force_y(i) = grav_force_y(i) + force_y ;
        
    end
    
    % Mache das selbe Prinzip fr die anderen Indizes auer i=j!
    
    for j = i+1:n
        
        % Berechne die Abstnde und die Steigungen untereinander
        r_square = max( (people_mat(j,1) - people_mat(i,1)).^2 + (people_mat(j,2) - people_mat(i,2)).^2, r_min^2);
        
        if people_mat(j,1) ~= people_mat(i,1)
        
            delta_square = (people_mat(j,2) - people_mat(i,2)).^2 ./ (people_mat(j,1) - people_mat(i,1)).^2;
        
            % Berechne die komponentenweisen Krfte
            force_x = c_2 ./ ( r_square .* sqrt( delta_square + 1 ) );
        
            force_y = ( c_2 .* sqrt( delta_square) ) ./ ( r_square .* sqrt( delta_square + 1 ) );
        
            % Bestimme die Richtung, in die die komponentenweise Kraft zeigt 
            % fr x
            
        else
            
            force_x = 0;
            force_y = ( c_2 ) ./ ( r_square );
            
        end
        
        if people_mat(j,1) < people_mat(i,1)
            
            force_x = - force_x;
            
        else

        end
        
        if people_mat(j,2) < people_mat(i,2)
            
            force_y = - force_y;
            
        else

        end   
        
        grav_force_x(i) = grav_force_x(i) + force_x ;
        
        grav_force_y(i) = grav_force_y(i) + force_y ;
        
    end
    
end
    