
% variable_force_lennard.m
% Berechnet die "Anziehungskraft" zwischen den Personen

function [lennard_force_x, lennard_force_y] = variable_force_lennard(people_mat,n,eps,sig_r,r_min)


% Initialisiert die Vektoren
lennard_force_x = zeros(n,1);

lennard_force_y = zeros(n,1);

% Berechne sigma aus dem Schulterradius

sig = (2 * sig_r) / 3;

r_min_square = r_min .^2;

% Berechne die Maximalen negativen Werte, an Krften, die bergeben werden
% drfen

force_max = 4 * eps * ( 2* (sig ^2 / r_min_square ^(3/2)) - 3 * (sig ^3 / r_min_square ^2) );


% Berechnungsschleife fr die x- und die y-Koordinate
% Jede Person agiert mit jeder

for i = 1:n
    
    for j = 1:i-1
        
        
        % Berechne die Abstnde und die Steigungen untereinander
        r_square = (people_mat(j,1) - people_mat(i,1)).^2 + (people_mat(j,2) - people_mat(i,2)).^2;
        
        if people_mat(j,1) ~= people_mat(i,1)
        
            delta_square = (people_mat(j,2) - people_mat(i,2)).^2 ./ (people_mat(j,1) - people_mat(i,1)).^2;
        
            if r_square > r_min_square % Wenn Abstand grer als r_min
        
                % Berechne die komponentenweisen Krfte
                force_x = 4 * eps * ( 2* (sig ^2 / r_square ^(3/2)) - 3 * (sig ^3 / r_square ^2) ) / ( sqrt( delta_square + 1 ) );
        
                force_y = 4 * eps * sqrt(delta_square) * ( 2* (sig ^2 / r_square ^(3/2)) - 3 * (sig ^3 / r_square ^2) ) / ( r_square .* sqrt( delta_square + 1 ) ); 
        
            else % Wenn Abstand kleiner als r_min (Vermeide unrealistische Krfte)
            
                force_x = force_max / sqrt( delta_square + 1 );
            
                force_y = ( force_max * sqrt(delta_square) ) / sqrt( delta_square + 1 );
            
            end
            
        else
            
            force_x = 0;
            
            force_y = force_max;
            
        end
            
        % Bestimme die Richtung, in die die komponentenweise Kraft zeigt
        % fr x
        
        if people_mat(j,1) < people_mat(i,1)
            
            force_x = - force_x;
            
        else

        end
        
        % Bestimme die Richtung, in die die komponentenweise Kraft zeigt
        % fr y
        if people_mat(j,2) < people_mat(i,2)
            
            force_y = - force_y;
            
        else

        end        
        
        % Summiere die einzelnen komponentenweisen Krfte zu einer
        % Gsamtkraft auf
        
        lennard_force_x(i) = lennard_force_x(i) + force_x ;
        
        lennard_force_y(i) = lennard_force_y(i) + force_y ;
        
    end
    
    % Mache das selbe Prinzip fr die anderen Indizes auer i=j!
    
    for j = i+1:n
        
        
        % Berechne die Abstnde und die Steigungen untereinander
        r_square = (people_mat(j,1) - people_mat(i,1)).^2 + (people_mat(j,2) - people_mat(i,2)).^2;
        
        if people_mat(j,1) ~= people_mat(i,1)
        
            delta_square = (people_mat(j,2) - people_mat(i,2)).^2 ./ (people_mat(j,1) - people_mat(i,1)).^2;
        
            if r_square > r_min_square % Wenn bstand grer als r_min
        
                % Berechne die komponentenweisen Krfte
                force_x = 4 * eps * ( 2* (sig ^2 / r_square ^(3/2)) - 3 * (sig ^3 / r_square ^2) ) / ( sqrt( delta_square + 1 ) );
        
                force_y = 4 * eps * sqrt(delta_square) * ( 2* (sig ^2 / r_square ^(3/2)) - 3 * (sig ^3 / r_square ^2) ) / ( r_square .* sqrt( delta_square + 1 ) ); 
        
            else % Wenn Abstand kleiner als r_min (Vermeide unrealistische Krfte)
            
                force_x = force_max / sqrt( delta_square + 1 );
            
                force_y = ( force_max * sqrt(delta_square) ) / sqrt( delta_square + 1 );
            
            end
            
        else
            
            force_x = 0;
            
            force_y = force_max;
            
        end
            
        % Bestimme die Richtung, in die die komponentenweise Kraft zeigt
        % fr x
        
        if people_mat(j,1) < people_mat(i,1)
            
            force_x = - force_x;
            
        else

        end
        
        % Bestimme die Richtung, in die die komponentenweise Kraft zeigt
        % fr y
        if people_mat(j,2) < people_mat(i,2)
            
            force_y = - force_y;
            
        else

        end        
        
        % Summiere die einzelnen komponentenweisen Krfte zu einer
        % Gsamtkraft auf
        
        lennard_force_x(i) = lennard_force_x(i) + force_x ;
        
        lennard_force_y(i) = lennard_force_y(i) + force_y ;
    end
    
end
    